//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "main.h"
#include <Inifiles.hpp>
#include "druck1.h"
#include "druck1.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
#pragma warn -ucp

char wotae[][3]={ "??","Mo","Tu","We","Th","Fr","Sa","Su" };
char wotad[][3]={ "??","Mo","Di","Mi","Do","Fr","Sa","So" };
//unsigned char buf[3333];
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner): TForm(Owner)
{
    comopen=0;                          //0=noch zu,  1=geoeffnet
	filepos = 0;

    LArbeitsverzeichnis->Caption = GetCurrentDir();
    MainForm->Caption = "Datlog (C) smatro";
    OpenDialog1->InitialDir = LArbeitsverzeichnis->Caption;
    SaveDialog1->InitialDir = LArbeitsverzeichnis->Caption;

    TIniFile *tif = new TIniFile(LArbeitsverzeichnis->Caption +"\\datlog.ini");
    comport = tif->ReadString("Default","comport","COM2");
    baud    = tif->ReadInteger("Default","baud",CBR_9600);
    delete tif;
    saveini();

    if(openport())						//ret=0: OK!
    {   MessageBox(0,"Kann COM-Port nicht ffnen !","Fehler",0);
        Application->Terminate();
    }
    HoleMinMax();
    ZeigeGrafik();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::saveini()
{   TIniFile * tif;

    tif = new TIniFile(LArbeitsverzeichnis->Caption +"\\datlog.ini");
    tif->WriteString("Default","comport",comport);
    tif->WriteInteger("Default","baud",baud);

    delete tif;
}
//---------------------------------------------------------------------------
//Timer-Routine, wird normalerweise alle 100ms aufgerufen:
//aktualis. der Uhranzeige und Schnittstelle prfen
void __fastcall TMainForm::Timer1Timer(TObject *Sender)
{	char  *ts;
    time_t t;

    time(&t);
    ts = ctime(&t);

    for(int f=0; f<8; f++)
    	if((wotae[f][0]==ts[0])&(wotae[f][1]==ts[1]))
        {	tag = (unsigned char)(f + 0xe0);
        	ts[0] = wotad[f][0];
            ts[1] = wotad[f][1];
            ts[3] = 32;
        }
	stunde = (unsigned char)(atoi(&ts[11]) + 0xc0);
    minute = (unsigned char)(atoi(&ts[14]) + 128);

	LDatumZeit->Caption = AS(ts);
    compruef();

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SetzteZeitClick(TObject *Sender)
{
	unsigned char buf[99];

	sprintf(buf,"%c%c%c%c%c%c",27,stunde,minute,tag,27,'R');
    sendcommand(AS((char*)buf));
    WrProt(AS((char*)buf));

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AnsEndeClick(TObject *Sender)
{
	filepos = 0xfffffff;
    ZeigeGrafik();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AnDenAnfangClick(TObject *Sender)
{
	filepos = 0;
    ZeigeGrafik();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::WeiterClick(TObject *Sender)
{
	filepos += 150;								//256 Schritte
    ZeigeGrafik();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ZurueckClick(TObject *Sender)
{
   	filepos -= 150;
    if(filepos < 0)
    	filepos = 0;
    ZeigeGrafik();
}

//---------------------------------------------------------------------------
//Aus dem akt. Flashfile die Max.- und Min-Werte laden
void __fastcall TMainForm::HoleMinMax(void)
{   int v;
	FILE* file = fopen("Flash.tmp","rb");
    if(file == NULL)	return;
    vmin = 0xffff;
    vmax = 0;
    while((v = fgetc(file))!=EOF)
    {	if(v < 128)
    	{	if(v < vmin)		vmin = v;
        	if(v > vmax)		vmax = v;
        }
        //else	WrProt(AS(v));
    }
    fclose(file);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ZeigeGrafik(void)
{
    int v, tag=0xff, stunde=0xff, minute=0xff;
    AS LastTime;

   	TRect r = Rect(0,0,Image1->Width,Image1->Height);
   	Image1->Canvas->FillRect(r);
	FILE* file = fopen("Flash.tmp","rb");
    if(file == NULL)	return;
    if(fseek(file,filepos,SEEK_SET))
		if(fseek(file,-100,SEEK_END))
        {	fclose(file);
        	return;
        }
	for(int x=20; x<Image1->Width; x++)
	{   v = fgetc(file);
    	if(v == EOF)	break;
        while(v>127)
        {   if(v<188)               minute = v & 0x7f;
            if((v>223)&(v<232))     tag = v & 0x0f;
            if((v>191)&(v<216))     stunde = v & 0x1f;
            v = fgetc(file);
        	if(v == EOF)	break;
        }
        Image1->Canvas->Pen->Color = (TColor)0xaa901;
        Image1->Canvas->Pen->Mode  = pmCopy;
        Image1->Canvas->MoveTo(x,Image1->Height - 20);
		Image1->Canvas->LineTo(x,Image1->Height - 20 - v*2 + vmin);
        if((tag!=255)&(stunde!=255)&(tag!=255))
        {   LastTime = AS(wotad[tag])+"/";
        	AS s = AS(stunde);
            if(s.Length()==1)	s = "0"+s;
            LastTime += s + ":";
            s = AS(minute);
            if(s.Length()==1)	s = "0"+s;
            LastTime += s;
            tag = stunde = minute = 0xff;
            Image1->Canvas->Pen->Mode  = pmMask;
            Image1->Canvas->Pen->Color =(TColor)0;
            Image1->Canvas->MoveTo(x,0);
		    Image1->Canvas->LineTo(x,Image1->Height-20);
	        Image1->Canvas->TextOut(x-5, Image1->Height-18, LastTime);
        }
    }
	fclose(file);

    for(v=Image1->Height-20; v>0; v -= 20)
    {   Image1->Canvas->Pen->Mode  = pmMask;
        Image1->Canvas->Pen->Color =(TColor)0;
        Image1->Canvas->MoveTo(20,v);
	    Image1->Canvas->LineTo(Image1->Width,v);
        Image1->Canvas->TextOut(1, v-6, AS(Image1->Height-v-20));
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DateiLadenClick(TObject *Sender)
{
	OpenDialog1->Title = "Flash-Datei vom PC laden.....";
    if(OpenDialog1->Execute())
    {   MainForm->Caption = OpenDialog1->FileName;
        //DeleteFile(LArbeitsverzeichnis->Caption+"\\"+"flash.tmp");
		CopyFile(MainForm->Caption.c_str(),"flash.tmp",false);
        HoleMinMax();
        ZeigeGrafik();
    }

}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DateiSpeichernClick(TObject *Sender)
{
	SaveDialog1->Title = "Flash-Datei abspeichern.....";
    SaveDialog1->FileName = MainForm->Caption;
    if(SaveDialog1->Execute())
    	CopyFile("flash.tmp",SaveDialog1->FileName.c_str(),0);
    MainForm->Caption = SaveDialog1->FileName;
}
//---------------------------------------------------------------------------
//Routine zum Vorbereiten und ffnen des COM-Ports  (ret=0: OK)
int __fastcall TMainForm::openport(void)
{
    if(comopen)     return 1;           //Ende (Port schon geoeffnet)

	//API-F versucht entspr. Port mit Param. zu ffnen (ret=-1: Fehler)
	hCom = CreateFile(comport.c_str(),  //Name des Ports z.B. "COM3"
		GENERIC_READ | GENERIC_WRITE,   //Lesen, Schreiben oder beides
		0,                              //exclusive access
		NULL,                           //no security attrs
		OPEN_EXISTING,                  //nur ffnen, wenn existent
		FILE_FLAG_OVERLAPPED,           //luft im Hintergrund
		NULL
		 );

	//wenn nicht erfolgreich, wird -1 zurckgegeben und PRG-Ende
	if (hCom == INVALID_HANDLE_VALUE)      return(2);

	//Festlegen der Puffergroessen fuer die Ein- und Ausgabe
	success = SetupComm(hCom, LESEBUFFER, SCHREIBBUFFER);
	if (!success)  return 5;             //Wenn nicht erfolgreich: Ende

	//Holen der (Default-) Schnittstellenkonfiguration (nach dcb)
	success =  GetCommState(hCom, &dcb);
    if (!success)  return 3;            //Wenn nicht erfolgreich: Ende

	//die eingelesenen Defaultdaten zum Teil berschreiben
	dcb.BaudRate           = baud;
    dcb.fBinary            = True;     //in Win95 eh kein Non-Bin-Mode
    dcb.fParity            = FALSE;
    dcb.fOutxCtsFlow       = FALSE;    //CTS nicht bercksichtigen
    dcb.fOutxDsrFlow       = FALSE;    //DSR auch nicht
    dcb.fDsrSensitivity    = 0;
    dcb.fTXContinueOnXoff  = 0;
    dcb.fOutX              = 0;
    dcb.fInX               = 0;
    dcb.fAbortOnError      = FALSE;    //auch bei Fehlern weitermachen
    dcb.ByteSize           = 8;        //Bits pro Byte
	dcb.StopBits           = 0;        //0,1,2  entspricht  1, 1.5, 2 Bits

	//Schreiben der (evt. genderten) Schnittstellenkonfiguration
   success =  SetCommState(hCom, &dcb);
   if (!success)  return 3;            //Wenn nicht erfolgreich: Ende

   // CreateEvent unbedingt ntig fr den Lauf im Hintergrund
   // Create an event object for use in WaitCommEvent (siehe WIN32.HLP)
   o.hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
   // zur Sicherheit fr den Empfang nochmal
   o2.hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
   if(!o.hEvent)      return(6);

   success = GetCommTimeouts(hCom, &times);
   if (!success)  return(7);
   times.ReadIntervalTimeout=100;       //max Wartezeit zwischen den Bytes
   success = SetCommTimeouts(hCom, &times);
   if (!success)  return(8);

   comopen=1;                           //ab jetzt ist Int erlaubt
   leseport();
   return 0;                            //0 heit hier OK!!
}

//---------------------------------------------------------------------------
//Routine wird normalerweise alle 100ms aufgerufen (Test, ob Send. oder Empf.)
void __fastcall TMainForm::compruef(void)
{
   inaktiv++;
   if(comopen==0)           return;//Com noch nicht geoeffnet!

   timertic++;                     //zum mitzaehlen

   /*if(closecomm)                   //Soll Comx geschlossen werden?
   {   comopen = closecomm = 0;    //Int darf nicht mehr sein
       PurgeComm(hCom, 15);        //alle Puffer lschen
       CloseHandle(hCom);
       return;
   }*/

   if(purgecomm)                   //sollen alle Puffer geloescht werden?
   {   purgecomm = 0;
       PurgeComm(hCom, 15);        //alle Puffer lschen
	   return;
   }

   GetOverlappedResult(hCom,&o2,&rb,false);
   ClearCommError(hCom, &errcode, &comstat);
   //Gre des RX-Puffers liegt jetzt in comstat.cbInQue
   bytesimschreibpuffer = comstat.cbOutQue;
   bytesimlesepuffer    = comstat.cbInQue;

   if(LSendbytes->Caption == 'M')	//Sofortmessung?
   {
  		Level->Width = (pccommin[0]*2)-10;
	 	Level->Caption = AS(pccommin[0]);
   }

   if((bytesimlesepuffer > 0)||(bytesimschreibpuffer > 0))
   {   LW->Caption = AnsiString((int)bytesimschreibpuffer);
       LR->Caption = AnsiString((int)bytesimlesepuffer);
   }


   //Vor dem Aufruf muss der zu sendende Inhalt in writebuffer stehen,
   //sowie die Zahl der zu sendenden Bytes in wblen (Ret: 0=OK)
   //Jetzt endlich los: Portausgabe im Hintergrund (wenn wblen gesetzt)
   if(wblen)                           //Zahl zu sendender Bytes
   {   success = WriteFile(hCom,       //Hndler des Port (von CreateF..)
                 writebuffer.c_str(),  //Adr. der zu sendenden Bytes
                 wblen,                //Zahl der Bytes
                 &transfer, &o);
       LSendbytes->Caption = writebuffer;
       inaktiv=0;
	   wblen=0;
	}

   if(rb)   //Zeichen empfangen?
   {    inaktiv=0;
		if(LSendbytes->Caption == 'F')
	    {	FILE* file = fopen("Flash.tmp","wb");
        	if(file != NULL)
			{   unsigned char x=1;
            	for(int f=0; f<(int)rb; f++)
            	{   if(pccommin[f]==255)	x++;
                	else					x=128;
                    if(!x)	break;
            		putc(pccommin[f], file);
                }
            	fclose(file);
	        }
			datastopClick(0);
            ZeigeGrafik();
        }
		if(LSendbytes->Caption == 'R')
	    {	for(int f=0; f<256; f++)	ram[f] = pccommin[f];
        	LMin->Caption = ram[0x60];
        	LStu->Caption = ram[0x61];
        	LTag->Caption = ram[0x62];
        }

        leseport();                     //nchster Lesevorgang
   }
}
//---------------------------------------------------------------------------
//In die Protokolldatei protok.txt knnen div. Meldungen geschr. werden,
//Aufruf:  WrProt(Prioritt(0=gering....2=hoch), AS-Meldungstext)
void __fastcall TMainForm::WrProt(AS PText)
{ int FileHandle;
  AS s;
  s = LArbeitsverzeichnis->Caption + "\\protok.txt";
  try
  {
    if(FileExists(s))      FileHandle = FileOpen(s,fmOpenReadWrite);
    else                   FileHandle = FileCreate(s);
    if(FileHandle== -1)     return;         //bei Fehler
    FileSeek(FileHandle,0,2);

    //text = Datum, Zeit, Spaces(hchste Prioritt vorn), Meldung
    s = "\r\n" + DateTimeToStr(Now()) + " --- " + " " + PText;
    FileWrite(FileHandle,s.c_str(),s.Length());
    FileClose(FileHandle);
  }
  catch(...) {}
  return;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::leseport(void)
{    ReadFile(hCom,              //Handler dieses Ports
              pccommin,  		 //wo die Bytes hin sollen
              LESEBUFFER,        //Zahl der Bytes, die zu lesen sind
              &gelesen,          //Ablage, wieviele gel. wurden
              &o2);              //notw. Overlapped-Struktur
}
//---------------------------------------------------------------------------
void TMainForm::sendcommand(AS co)
{
 	writebuffer = co;
    wblen = writebuffer.Length();
    WrProt("PC->Datlog:  " + writebuffer);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FlashLesenClick(TObject *Sender)
{
	sendcommand('F');
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SofortMessungClick(TObject *Sender)
{
   times.ReadIntervalTimeout=10;       //max Wartezeit zwischen den Bytes
   success = SetCommTimeouts(hCom, &times);
   sendcommand('M');
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::p1minClick(TObject *Sender)
{
	sendcommand("LP");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::datastopClick(TObject *Sender)
{
    times.ReadIntervalTimeout=100;       //max Wartezeit zwischen den Bytes
    success = SetCommTimeouts(hCom, &times);
    sendcommand(AS((char)27)+AS((char)27)+AS((char)27));
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RAMlesenClick(TObject *Sender)
{
	sendcommand('R');
    //ZeigeGrafik();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FlashLoeschenClick(TObject *Sender)
{
	sendcommand('C');
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::p1sekClick(TObject *Sender)
{
	sendcommand("1P");
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::p6sekClick(TObject *Sender)
{
	sendcommand("6P");
}
//---------------------------------------------------------------------------/* Beispiele noch in Examples einfgen:
void __fastcall TMainForm::Button1Click(TObject *Sender)
{
    //FDruck1->QuickRep1->Preview();
}
//---------------------------------------------------------------------------

/*
    	TRect r = Rect(0,0,FlImage->Width,FlImage->Height);
    	FlImage->Canvas->FillRect(r);
    	FlImage->Canvas->Pen->Width = 2;				//Rahmen zeichnen
		FlImage->Canvas->Pen->Style = psSolid;
		FlImage->Canvas->MoveTo(0,0);
		FlImage->Canvas->LineTo(0,FlImage->Height);
		FlImage->Canvas->LineTo(FlImage->Width,FlImage->Height);
		FlImage->Canvas->LineTo(FlImage->Width,0);
		FlImage->Canvas->LineTo(0,0);

		FlImage->Canvas->Pixels[100][100] = (TColor)0;
		FlImage->Canvas->Pixels[100][101] = (TColor)0;
		FlImage->Canvas->Pixels[100][102] = (TColor)0;

		FlImage->Canvas->Pen->Width = 1;				//senkrechte Punktlinien
		FlImage->Canvas->Pen->Style = psDot;
		for(int y=60; y<FlImage->Width; y +=60)			//in diesem Abstand
		{	FlImage->Canvas->MoveTo(y,0);
			FlImage->Canvas->LineTo(y,FlImage->Height);
		}
		FlImage->Canvas->Pen->Style = psSolid;
		FlImage->Canvas->Pen->Width = 1;
*/


