// RK, 070997  Variante zum Ansprechen der Ports (COMx)  
// Die COM-Routinen werden mittels API-Routinen erzeugt.
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <dos.h>
#include <dir.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "grafik2.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
#define LESEBUFFER 10300           //Groesse des Lesepuffers
#define SCHREIBBUFFER 10300
//---------------------------------------------------------------------------
//Int-Variablen (Schreiben nur in der Int-Routine erlaubt)
COMSTAT comstat;                   //Stru.mit ca. 10 Eintrgen (Handshake)
DWORD errcode;                     //wird von ClearCommError geliefert
unsigned int bytesimschreibpuffer; //Zahl der noch zu sendenden Bytes
unsigned int bytesimlesepuffer;    //noch nicht in pccommin   bertr. Bytes
unsigned long timertic = 0;        //wird pro Int-Routine erhoeht
unsigned long inaktiv = 0;			//wie timertic, nur bei Schreib-Leseop. auf 0
unsigned long rb;                  //Die im Lesepuffer zur Verf. st. Bytes
unsigned short int x, pruefsumme;

struct ffblk ffblk;
TForm1 *Form1;
int comopen=0;                     //0=noch zu,  1=geoeffnet

struct time zeit;
struct date datum;
char cfg[266]="comvar.cfg";        //In der CFG-Dateien sind viele Variablen
char pfad[255];                    //Das akt. Arbeitsverzeichniss
char genr[9]="BG000";              //Geraetenummer fuer Datenaustausch
char absender[9];                  //von dem die letzte Nachricht kam
char befehlstyp[80];               //Befehl in der Nachricht
char bytezahl[9];                  //alle Bytes in der Nachricht (Text)
int  bytes;                        // -"- (Int)
char *datenstart;                  //Pointer, wo die Daten beginnen
int  daten;                        //Anzahl, wie viele es sind
char comport[9];                   //COM1....
char baud[9];                      //9600 oder 1200 oder ...
COMMTIMEOUTS times;                //die Timeout-Variablen des Ports
HANDLE hCom;                       //Adresse des COMPORT-Hndlers
OVERLAPPED o,o2;                   //Struktur enthlt Infos ber I/O-Daten
BOOL success;                      //Erfolg (Ja/Nein)
//ORD dwEvtMask;                   //Ereignismaske, wann immer UP-Ruf
DCB dcb;                           //Devicecontrollblock (ca.28 Eintrge)
DWORD transfer;
unsigned char pccommin[LESEBUFFER];//nach Timeout kommen gel.Bytes hier hin
char *pccommptr;
char writebuffer[SCHREIBBUFFER];   //Diesen Pufferinhalt zum Port senden
unsigned int wblen;                //Bytezahl im writepuffer + Start im Int
unsigned long gelesen;             //F schreibt ein, wieviel Bytes gelesen
unsigned int purgecomm = 0;        //>0: loescht alle Puffer im Int-Prg
unsigned int closecomm = 0;        //>0: schliesst die Schnittstelle
unsigned int lese = 1;             //=1: Leseaktion (Hintergrund) starten
unsigned int neuesprotokoll = 1;   //=1: neue Protokolldaten in Datenbank schr.
unsigned int table_exist = 0;	    //=1: die Tabelle fr die Prod.-Daten ist da
unsigned int hinweisbox1 = 1;		//Hinweis, da vor Transfer Kontakt-PC einst.
//char protokdat[255];				//Pfad und Dateiname der Protokoll-Datei
char tablename[]="produkt.db";
char intbuf[399];                  //Buffer, der im Interrupt benmuzt wird
char contakt[9]="       ";         //smartpc-Name der kontaktiert wird
char activdate[]="datum       ";
char activname[300]="         /19971206.002";

//---------------------------------------------------------------------------
//F wird beim Anlegen der Form aufgerufen
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner)
{  char buf[300], buf2[300];
	FILE *temp;

   getcwd(pfad,256);                               //Den Arbeitspfad holen
   //Wenn 's die Wurzel ist, dann '\' weg, sonst gibt's mal 'c:\\..' (z.B.)
   if(pfad[strlen(pfad)-1]=='\\')   pfad[strlen(pfad)-1]=0;
	pfadanzeige->Caption = (AnsiString)pfad;
   _searchstr(cfg, "", buf);                       //ist die CFG-Datei da?
   if (buf[0] == '\0')
   {   prgende(1,cfg);
		return;
   }
   sprintf(cfg,"%s",buf);                          //Pfad+Datname in cfg
   _searchstr("labels", "", buf);                  //ist die diese UV da?
   if (buf[0] == '\0')   mkdir("LABELS");
   _searchstr("activ", "", buf);                   //ist die diese UV da?
   if (buf[0] == '\0')   mkdir("ACTIV");

   init();
   outfileboxload();
   openport();
	TabbedNotebook1->PageIndex = 0;
   Label15->Visible = false;

	//Prfen, ob die Datenbanktabelle verfgbar ist
   GetPrivateProfileString("default","prodtable",pfad,buf2,295,cfg);
   if(buf2[strlen(buf2)-1]=='\\')   	buf2[strlen(buf2)-1]=0;
   sprintf(buf,"%s\\%s",buf2,tablename);
   if(0 == (temp=fopen(buf,"rb")))
   {   sprintf(buf2,"%s nicht zu finden ! \rLaufwerk und Pfad von  %s  "
			         "in die Konfigurationsdatei %s\rim Abschnitt "
                    "[default]  nach  prodtable=  eintragen !",
                    buf,tablename,cfg);
      	MessageBox(0,buf2, "Produktionsdatenbankdatei nicht vorhanden !",MB_OK);
   }
	else
   {  	table_exist = 1;
		fclose(temp);
        Table1->DatabaseName = buf2;
		Table1->TableName = tablename;
   }
   //Application->Minimize();						//Hauptfenster in Hintergrund
}
//---------------------------------------------------------------------------
int __fastcall TForm1::init(void)
{
	GetPrivateProfileString("default","geraetenummer","?",genr,8,cfg);
    if(genr[0]=='?')         return(prgende(3,cfg));
	gnr->Caption = (AnsiString)genr;

	GetPrivateProfileString("default","comport","?",comport,5,cfg);
    if(comport[0]=='?')      return(prgende(4,cfg));

	GetPrivateProfileString("default","baudrate","?",baud,7,cfg);
	if(comport[0]=='?')      return(prgende(5,cfg));

	comboboxget(comportbox,"comport");
	comboboxget(baudrate,"baudrate");
	comboboxget(connectbox,"connect");

	return 0;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::comboboxget(TComboBox *cbadr, char *section)
{  char buf[300], buf2[16];

	//Wenn die Eintraege noch nicht geladen wurden, dann jetzt!
   if(cbadr->Items->Count < 1)
	{	cbadr->Items->Clear();                  	//Combobox leeren

   	for(int x=1; (buf[0]!='?'); x++)  			//bis kein Eintrag mehr
		{	sprintf(buf2,"%u",x);					//String fuer die Uebergabe
		    if(x>1)		cbadr->Items->Add((AnsiString)buf);
   		GetPrivateProfileString(section,buf2,"?",buf,300,cfg);
	    }
	}
	GetPrivateProfileString("default",              //Sektionsname ([xyz])
				     		section,                //Schluesselname
				     		"?",                    //default, wenn nix da
				     		buf,                    //wo Inhalt hin soll
				     		300,                    //Laenge von buf
				     		cfg);                   //Dateiname

	if(buf[0]=='?')  	prgende(7,section);         //kein Eintrag in der CFG
	cbadr->Text = AnsiString(buf);		    	    //Eintrag dazu

	//return 0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::comboboxset(TComboBox *cbadr, char *section)
{  char buf[300];

	if(cbadr->ItemIndex < 0)
	{	GetPrivateProfileString("default",          //Sektionsname ([xyz])
								section,            //Schluesselname
								"?",                //default, wenn nix da
								buf,                //wo Inhalt hin soll
								300,                //Laenge von buf
								cfg);               //Dateiname
		cbadr->Text = AnsiString(buf);
   }
	else
   {	WritePrivateProfileString("default",section,
			 cbadr->Items->Strings[cbadr->ItemIndex].c_str(),cfg);
		cbadr->Text = cbadr->Items->Strings[cbadr->ItemIndex];
	}
}

//---------------------------------------------------------------------------

void __fastcall TForm1::portoeffnenClick(TObject *Sender)
{
   init();
   openport();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::comportboxChange(TObject *Sender)
{
	comboboxset(comportbox, "comport");
	init();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::baudrateChange(TObject *Sender)
{
	comboboxset(baudrate,"baudrate");
	init();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::connectboxChange(TObject *Sender)
{
	comboboxset(connectbox,"connect");
	init();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::leseport(void)
{    ReadFile(hCom,              //Handler dieses Ports
              pccommin  ,        //wo die Bytes hin sollen
              LESEBUFFER,        //Zahl der Bytes, die zu lesen sind
              &gelesen,          //Ablage, wieviele gel. wurden
              &o2);              //notw. Overlapped-Struktur
}
//---------------------------------------------------------------------------
//UP sucht nach dem naechsten Komma im Stream, Return > Pointer danach
 char * __fastcall TForm1::copy2nextkomma(char *von, char *nach, int max)
{  while((*von) != ',')
   {    if(*von<31)     *nach = '?';
        else            *nach = *von;
        von++;
        nach++;
        *nach = 0;
        if(!(--max))    break;
   }
   return ++von;                  //zeigt auf nach dem Komma
}

//---------------------------------------------------------------------------
int __fastcall TForm1::openport(void)
{  if(comopen)     return (comopenerror(9));   //Ende (Port schon geoeffnet)

	//API-F versucht entspr. Port mit Param. zu ffnen (ret=-1: Fehler)
	hCom = CreateFile(comport,                  //Name des Ports z.B. "COM3"
		GENERIC_READ | GENERIC_WRITE,           //Lesen, Schreiben oder beides
		0,                                      //exclusive access
		NULL,                                   //no security attrs
		OPEN_EXISTING,                          //nur ffnen, wenn existent
		FILE_FLAG_OVERLAPPED,                   //luft im Hintergrund
		NULL
		 );

	//wenn nicht erfolgreich, wird -1 zurckgegeben und PRG-Ende
	if (hCom == INVALID_HANDLE_VALUE)      return(comopenerror(1));

	//Festlegen der Puffergroessen fuer die Ein- und Ausgabe
	success = SetupComm(hCom, LESEBUFFER, SCHREIBBUFFER);
	if (!success)  return(comopenerror(5));     //Wenn nicht erfolgreich: Ende

	//Holen der (Default-) Schnittstellenkonfiguration (nach dcb)
	success =  GetCommState(hCom, &dcb);
   if (!success)  return(comopenerror(2));     //Wenn nicht erfolgreich: Ende

	//die eingelesenen Defaultdaten zum Teil berschreiben
   dcb.BaudRate           = atoi(baud);
   dcb.fBinary            = True;     //in Win95 eh kein Non-Bin-Mode
   dcb.fParity            = FALSE;
   dcb.fOutxCtsFlow       = FALSE;    //CTS nicht bercksichtigen
   dcb.fOutxDsrFlow       = FALSE;    //DSR auch nicht
   dcb.fDsrSensitivity    = 0;
   dcb.fTXContinueOnXoff  = 0;
   dcb.fOutX              = 0;
   dcb.fInX               = 0;
   dcb.fAbortOnError      = FALSE;    //auch bei Fehlern weitermachen
   dcb.ByteSize           = 8;        //Bits pro Byte
	dcb.StopBits           = 0;        //0,1,2  entspricht  1, 1.5, 2 Bits

	//Schreiben der (evt. genderten) Schnittstellenkonfiguration
   success =  SetCommState(hCom, &dcb);
   if (!success)  return(comopenerror(3));     //Wenn nicht erfolgreich: Ende

   // CreateEvent unbedingt ntig fr den Lauf im Hintergrund
   // Create an event object for use in WaitCommEvent (siehe WIN32.HLP)
   o.hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
   // zur Sicherheit fr den Empfang nochmal
   o2.hEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
   if(!o.hEvent)      return(comopenerror(6));

   success = GetCommTimeouts(hCom, &times);
   if (!success)  return(comopenerror(7));
   times.ReadIntervalTimeout=1000;
   success = SetCommTimeouts(hCom, &times);
   if (!success)  return(comopenerror(8));

   comopen=1;                      //ab jetzt ist Int erlaubt
   portoeffnen->Enabled = false;   //Button grau machen
   CloseCom->Enabled = true;       //Button wieder voller Kontrast
   comportbox->Enabled = false;
   baudrate->Enabled = false;
   leseport();
   return 0;
}

//---------------------------------------------------------------------------
//Timer-Routine, wird normalerweise alle 100ms aufgerufen
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{  unsigned short int x;
   FILE *file;
	inaktiv++;
   if(comopen==0)           return;//Com noch nicht geoeffnet!
   timertic++;                     //zum mitzaehlen
   //Wenn Protokoll empfangen, dann nach best. Zeit in die Datenbank
   if((inaktiv>20)&&(neuesprotokoll == 1))		tablesave();

   if(closecomm)                   //Soll Comx geschlossen werden?
   {   comopen = closecomm = 0;    //Int darf nicht mehr sein
       PurgeComm(hCom, 15);        //alle Puffer lschen
		CloseHandle(hCom);
       CloseCom->Enabled = false;  //Button grau machen
       portoeffnen->Enabled = true;    //Button wieder voller Kontrast
       comportbox->Enabled = true;
		baudrate->Enabled = true;
       return;
   }

	if(purgecomm)                   //sollen alle Puffer geloescht werden?
   {   purgecomm = 0;
       PurgeComm(hCom, 15);        //alle Puffer lschen
		return;
   }

   GetOverlappedResult(hCom,&o2,&rb,false);
   ClearCommError(hCom, &errcode, &comstat);
   //Gre des RX-Puffers liegt jetzt in comstat.cbInQue
   bytesimschreibpuffer = comstat.cbOutQue;
   bytesimlesepuffer    = comstat.cbInQue;
   x = 0;
   if((timertic % 10)==0)		   x = 1;
   if(bytesimlesepuffer > 0)       x = 1;
   if(bytesimschreibpuffer > 0)    x = 1;
   if(x > 0)
   {   Label1->Caption = AnsiString((int)bytesimschreibpuffer);
	   Label1->Refresh();
       Label2->Caption = AnsiString((int)bytesimlesepuffer);
       Label2->Refresh();
   }

   //Vor dem Aufruf muss der zu sendende Inhalt in writebuffer stehen,
   //sowie die Zahl der zu sendenden Bytes in wblen (Ret: 0=OK)
   //Jetzt endlich los: Portausgabe im Hintergrund (wenn wblen gesetzt)
   if(wblen)                           //Zahl zu sendender Bytes
   {   success = WriteFile(hCom,       //Hndler des Port (von CreateF..)
                 writebuffer,          //Adr. der zu sendenden Bytes
                 wblen,                //Zahl der Bytes
                 &transfer, &o);
       if(wblen>90)     wblen=90;
		Label5->Caption = AnsiString(writebuffer,(unsigned char)wblen);
		Label5->Refresh();
       inaktiv=0;
		wblen=0;
	}

   if(rb)
   {
       //Die ersten Zeichen men ASCII sein !!
       for(x=0; (x<(unsigned short)rb) && (x<80); x++)
           if(pccommin[x]<31)   break;
       if(x<15)    goto leseend;                   //mind. so viel
       inaktiv=0;

		Label5->Caption = AnsiString((char*)pccommin,(unsigned char)x);
		Label5->Refresh();
       //Im Puffer liegen jetzt Daten, die ausgewertet werden men
       if(strncmpi((char*)pccommin,genr,strlen(genr)))   goto leseend;
       //Absender,Befehl und Bytes rausfischen
       pccommptr = copy2nextkomma((char*)pccommin,absender,8); //nur Pointerkorr.
       pccommptr = copy2nextkomma(pccommptr,absender,8);
       pccommptr = copy2nextkomma(pccommptr,befehlstyp,79);
		datenstart = copy2nextkomma(pccommptr,bytezahl,8);
       bytes = atoi(bytezahl);
       if(bytes>10000)    goto leseend;
       pruefsumme = 0;
       for(x=0; x<(unsigned short)bytes; x++)     pruefsumme += pccommin[x];
       //Fileende klar machen
       pccommin[x+8]=0;
       if(pruefsumme != pccommin[x]+256*pccommin[x+1])     goto leseend;
       if(pccommin[x-1]!=',')                              goto leseend;
       daten = (char*)&pccommin[x-1] - datenstart;

       sprintf(intbuf,"%.3s,von:%.5s, %04uBytes(%05u), "
                      "   in die PC-Datei:  ",
					   befehlstyp,absender,daten,pruefsumme);
       x = (unsigned short)strlen(intbuf);


       if(strncmpi(befehlstyp,"PRO",3)==0)
       {    sprintf(&intbuf[x],"%s\\PROTOK.DAT",pfad);
			 neuesprotokoll = 1;
       }
       else
           sprintf(&intbuf[x],"%s\\activ\\%.12s",pfad,&befehlstyp[3]);

       if(0!=(file=fopen(&intbuf[x],"wb")))
       {   protokoll(intbuf);
           while(daten--)   fputc(*datenstart++,file);
           fclose(file);
       }

       leseend:
       leseport();                                 //next Lesevorgang
	}
}

//---------------------------------------------------------------------------
//Der Buton Transfer starten wurde gedrckt
int __fastcall TForm1::comopenerror(int err)
{  char buf[80];

   sprintf(buf,"Fehler Nummer: %u",err);
   MessageBox(0,buf, "Fehler beim ffnen der seriellen Schnittstelle",MB_OK);
	return err;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::outfileboxload(void)
{
    int find=0, outzaehl=0;
    char buf[80];

    outfilebox->Items->Clear();                  	//Combobox leeren
    while(!find)
    {   if(!outzaehl)
        {   sprintf(buf," Senden von Labeldateien aus %s\\labels"
                        " an einen smartpc",pfad);
            GroupBox2->Caption = (AnsiString)buf;
            GroupBox2->Refresh();
            //outfilebox->Items->Add((AnsiString)buf);
            sprintf(buf,"%s\\labels\\*.out",pfad);
			 find=findfirst(buf,&ffblk,0);
            if (find)    return;                   //wenn keine da sind
        }
        else
           find=findnext (&ffblk);//Funktion fr weitere Suche

        //hurra, es wurden Outs gefunden!!
        if(!find)
        {   outzaehl++;
            outfilebox->Items->Add((AnsiString)ffblk.ff_name);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CloseComClick(TObject *Sender)
{
   closecomm=1;                    //beim naechsten Timer-Interrupt
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PurgecommClick(TObject *Sender)
{
   purgecomm = 1;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::neulesenClick(TObject *Sender)
{
   lese=1;                         //Lesestart
}
//---------------------------------------------------------------------------
//F bereitet den zu sendenden String auf und schickt ihn an die Senderoutine
//Format: an,von,befehlstyp,00000(bytezahl),daten,00000(pruefsumme)
//bytezahl & pruefsumme: vom Start bis Ende der Daten
int __fastcall TForm1::machesendestring(char *an,
                                        char *befehlstyp,
                                        char *daten,
                                        unsigned int  datlaenge)
{
   char *bzptr,                    //Startpunkt, Zahl der Bytes (00000)
        *datptr,                   //Startpunkt der Daten
        *psptr;                    //Startpunkt der Pruefsumme
   char heute[18];                 //Zeit & Datum fuer Z-Befehl
   unsigned int x;
   unsigned short int y;

   if(befehlstyp[0]=='Z')          //Z: Zeit versenden
   {   gettime(&zeit);
       getdate(&datum);
       sprintf(heute,"%04u%02u%02u%02u%02u%02u",
               datum.da_year,datum.da_mon,datum.da_day,
				zeit.ti_hour,zeit.ti_min,zeit.ti_sec);
       daten = heute;
       datlaenge = strlen(heute);
	}
   sprintf(writebuffer,"%s,%s,%s,00000,",an,genr,befehlstyp);
   bzptr  = writebuffer+strlen(an)+strlen(genr)+strlen(befehlstyp)+3;
   datptr = bzptr + 6;
   sprintf(bzptr,"%05u",datptr+datlaenge-writebuffer+1);
   bzptr[5] = ',';
	for(x=0; x<datlaenge; x++)      datptr[x] = daten[x];
   datptr[x] = ',';                //noch 'n Komma vor der Pruefsumme
   psptr = & datptr[x+1];          //hier die Pruefsumme
   y=0;
   for(x=0; &writebuffer[x]<psptr; x++)       y += writebuffer[x];
   psptr[0] = (char)(y & 255);
   psptr[1] = (char)(y / 256);
   //In wblen stehen jetzt die Zahl aller Bytes (Start->Ende Pruefs.)
	wblen = psptr + 5 - writebuffer;
	Label2->Caption = AnsiString(psptr);
   Label2->Refresh();
   return 0;

}
//---------------------------------------------------------------------------
int __fastcall TForm1::prgende(int fn, char *text)
{  char buf[80];

	if(fn==1)   sprintf(buf,"Datei %s nicht im Verzeichniss",text);
	if(fn==2)   sprintf(buf,"In %s ungltiger comport-Wert",text);
	if(fn==3)   sprintf(buf,"In %s ungltiger Wert(Ger.-Nr.)",text);
	if(fn==4)   sprintf(buf,"In %s ungltiger Wert(Comport)",text);
	if(fn==5)   sprintf(buf,"In %s ungltiger Wert(Baudrate2)",text);
	if(fn==6)   sprintf(buf,"Im Arbeitsverz. mu Pfad: %s vorh. sein!",text);
	if(fn==7)   sprintf(buf,"CFG-Datei: in [default] fehlt %s=... ?",text);

	MessageBox(0,buf, "Programmabbruch",MB_OK);
   Application->Terminate();						//alles beenden
   return fn;
}

//---------------------------------------------------------------------------
void __fastcall TForm1::TabbedNotebook1Change(TObject *Sender, int NewTab,
	bool &AllowChange)
{  FILE *file;
	char buf[99], c;
	int  spalte = 0;

	if(NewTab==1)
	{   activdatanzeige();
		sprintf(contakt,"%.5s",connectbox->Text.c_str());
		activfileboxload();
	}
	if(NewTab==2)
	{   RichEdit3->Lines->Clear();
		sprintf(buf,"%s\\protok.dat",pfad);
		if(0==(file=fopen(buf,"rb")))
		{	MessageBox(0,buf, "Protokolldatei lt sich nicht ffnen !",MB_OK);
			return;
		}
		while(!feof(file))
		{   c = (char)fgetc(file);
			if((c == 13)||(spalte>90)||(c == '@'))
			{   buf[spalte] = 13;
				buf[spalte+1] = 0;
				RichEdit3->Lines->Add(AnsiString(buf));
				spalte = 0;
			}
			if(c == '@')  break;
			if(c>31)    buf[spalte++] = c;
		}
		RichEdit3->Refresh();
		fclose(file);
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::activdatanzeige(void)
{  char buf[80], buf2[20],c;
	int zeile, spalte;
	FILE *file;

	RichEdit2->Lines->Clear();
	sprintf(buf2,"%s",activfilebox->Text.c_str());
   sprintf(activdate,"%s",buf2);
	sprintf(buf,"%s\\activ\\%c%c%c%c%c%c%c%c.%s",pfad,buf2[6],buf2[7],buf2[8],
				 buf2[9],buf2[3],buf2[4],buf2[0],buf2[1],&contakt[2]);
	sprintf(activname,"%s",buf);
	Label14->Caption = (AnsiString)buf;
	if(0!=(file=fopen(buf,"rb")))
	{   for(zeile=0; zeile<24; zeile++)
	   {   sprintf(buf,"%02u Uhr ->        ",zeile);
			for(spalte=0; spalte<60; spalte++)
			{   c = (char)fgetc(file);
				if(c=='s')    c = 'x';
				buf[spalte+11] = c;
			}
			buf[spalte+11] = 0;
			RichEdit2->Lines->Add(AnsiString(buf));
		}
		fclose(file);
		RichEdit2->Refresh();
	}
}

//---------------------------------------------------------------------------
void __fastcall TForm1::activfilebxChange(TObject *Sender)
{
   activdatanzeige();
}

//---------------------------------------------------------------------------
void __fastcall TForm1::activfileboxload(void)
{
    int find=0, artzaehl=0;
    char buf[80];

	 activfilebox->Items->Clear();                  	//Combobox leeren
	 //sprintf(buf,"%s\\activ\\*.%s",pfad,&contakt[2]);
	 //activfilebox->Text = buf;
	 while(!find)
	 {   if(!artzaehl)
		 {   sprintf(buf,"%s\\activ\\*.%s",pfad,&contakt[2]);
			 find=findfirst(buf,&ffblk,0);
			 if (find)                    //wenn keine da sind
			 {   //activfilebox->Text = "Keine Dateien im Pfad !";
				 return;
			 }
		 }
		 else
			find=findnext (&ffblk);//Funktion fr weitere Suche

		 //hurra, es wurden Outs gefunden!!
		 if(!find)
		 {   artzaehl++;
			 //gefundene Datei anzeigen
			 buf[0] = ffblk.ff_name[6];
			 buf[1] = ffblk.ff_name[7];
			 buf[3] = ffblk.ff_name[4];
			 buf[4] = ffblk.ff_name[5];
			 buf[6] = ffblk.ff_name[0];
			 buf[7] = ffblk.ff_name[1];
			 buf[8] = ffblk.ff_name[2];
			 buf[9] = ffblk.ff_name[3];
			 buf[2] = '.';
			 buf[5] = '.';
			 buf[10]= 0;
			 activfilebox->Items->Add((AnsiString)buf);
		 }
	 }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::labeltransfer(TObject *Sender)
{   FILE *file;
    char labelname[99];
    char *bzptr;               //wo die 5 Nullen (Zahl der Bytes) stehen
    char buf[80];
    int y;

    sprintf(labelname,"%s",outfilebox->Text.c_str());
    sprintf(buf,"%s\\labels\\%s",pfad,labelname);
    if(0==(file=fopen(buf,"rb")))
	 {    MessageBox(0,buf, "Fehler beim ffnen der Datei !",MB_OK);
         return;
	 }
    if(comopen==0)
    {   MessageBox(0,"Schnittstelle noch nicht geffnet !", "Fehler !",MB_OK);
        return;
	 }
    if(hinweisbox1++ < 3)
       MessageBox(0,"Bei Problemen bitte daran denken, da der richtige "
                    "smartpc mit 'Kontakt mit' ausgewhlt wurde !",
                     " Hinweis",MB_OK);
	 sprintf(contakt,"%.5s",connectbox->Text.c_str());
    sprintf(buf,"----------- Sende Labeldatei %s an:%s -----------",
    			labelname,contakt);
    protokoll(buf);
    sprintf(writebuffer,"%s,%s,LAB%s,00000,",contakt,genr,labelname);
    bzptr = writebuffer + 16 + strlen(labelname);
    y = (unsigned short int) strlen(labelname) + 22;
    while(!feof(file))     writebuffer[y++]=(char)fgetc(file);
    fclose(file);
    writebuffer[--y] = ',';
    writeprepare(writebuffer,bzptr,&writebuffer[y+1]);
    wblen = y+3;
  /*  pccommend = &pccommin[x+5];                //Ende hinter der Pruefs.
    pccommptr = pccommin;
	 intimer = 10000; */

}
//---------------------------------------------------------------------------
//UP berechnet Pruefsumme und Bytezahl,  Uebergabe folgender Parameter:
//Start des Feldes, Adr Bytezahl, Adr Pruefsumme
//Die Werte werden gleich in die Felder eingesetzt
void __fastcall TForm1::writeprepare(char *start,char *bz, char *ps)
{  unsigned short int y, x;

   sprintf(bz, "%05u", ps-start);
   bz[5]=',';                          //wieder , da sprintf 0 gesetzt hat
   y=0;
   for(x=0; x<ps-start; x++)      y += (unsigned char)(start[(int)x]);
   (unsigned char)ps[0] = (unsigned char) (y & 255);
   (unsigned char)ps[1] = (unsigned char) ((y>>8) & 255);
   //sprintf(ps, "%04X", y);
}

//---------------------------------------------------------------------------
void __fastcall TForm1::protokoll(char *text)
{
	 RichEdit1->Lines->Add(AnsiString(text));
	 if(RichEdit1->Lines->Count>17)   RichEdit1->Lines->Delete(0);
	 RichEdit1->Refresh();
	 TabbedNotebook1->PageIndex = 0;
}
//---------------------------------------------------------------------------
//Daten der Protokolldatei in die Datenbank legen
void __fastcall TForm1::tablesave(void)
{  FILE *file;
   char buf[255];
   int ptr= 0, count=0;

   neuesprotokoll = 0;
   //Wenn die Tabelle im Pfad nicht existiert, dann ist hier Feierabend
   if(table_exist==0) 	return;

   //Versuch mittels BDE die Datenbank zu bearbeiten
   try
   {   Table1->Active = true;
       sprintf(buf,"%s\\PROTOK.DAT",pfad);
	   if(0==(file=fopen(buf,"r")))		return;
       strnset(buf, ' ', 250);
       GroupBox2->Visible = false;
       Label15->Visible = true;
       while(!feof(file))
       {   int zeichen = fgetc(file);
       	   if(ptr<250)		buf[ptr++]=(char)zeichen;
           if((zeichen<32)||(zeichen=='@'))
           {	if(ptr>42)							//wenn Position >=bis
           		{   if(setdbdat(buf)) 	count++;	//und Zeile in die Datenbank
       			    Label15->Caption = AnsiString(buf);
		            Label15->Refresh();
			        strnset(buf, ' ', 250);
                }
            	ptr = 0;
           }
           if(zeichen=='@')		break;
       }
       //sprintf(buf,"%u neue Datenstze zur Datenbank bertragen !",count);
       //MessageBox(0,buf,"Achtung !", MB_OK);
       sprintf(buf,"%u Datenstze neu in die Datenbank eingefgt !",count);
	   Label15->Caption = AnsiString(buf);
       Label15->Refresh();
       MessageBeep(0xFFFFFFFF);
       Sleep(5000);
       Label15->Visible = false;
       GroupBox2->Visible = true;
       Table1->Active = false;
	}
	catch(Exception &exception)
    {
	    Label15->Visible = false;
        GroupBox2->Visible = true;
	  	MessageBox(0,"Datenbank- oder BDE-Problem, es konnten keine "
        		     "Daten in die Datenbank bertragen werden !",
                     "Achtung !",MB_OK);
		Table1->Active = false;
	}
}
//---------------------------------------------------------------------------
//Die Daten in dem ankommende String werden in die Datenbank geschrieben
//ret=1: neuer Datensatz bernommen
int __fastcall TForm1::setdbdat(char *buf)
{  //1=Zeichen, 2=Ziffer, 3=Komma, 4='-' (zur Prfung)
   char typ[] ="11222322222222322223229";		//Ende: Datname min 2 Ziffern
   char typ2[]="22223222222223222222229";
   char buf2[]="             ";
   int x=0, y, dl;

   for(dl=1; dl<10; dl++)						//Laenge des Dateinamens
   if(!isdigit(buf[19+dl]))   	break;			//wenn keine Ziffer
   if(dl>8)	return 0;							//Labellaenge>8 gibts nicht!
   if(dl<2)	return 0;							//Labellaenge<2 gibts nicht!
   //dl++;										//Laenge incl. Endkomma

	//Pruefung bis Dateiname
   while(typ[x]!='9')
   {    if(typ[x]=='1')		if(!isalnum(buf[x]))		return 0;
	    if(typ[x]=='2')		if(!isdigit(buf[x]))		return 0;
	    if(typ[x]=='3')		if(buf[x]!=',')				return 0;
	    if(typ[x]=='4')		if(buf[x]!='-')				return 0;
		x++;
   }
   //Pruefung hinter dem Dateiname
   x=0;
   while(typ2[x]!='9')
   {   if(typ2[x]=='2')	if(!isdigit(buf[x+dl+20]))	return 0;
       x++;
   }

   sprintf(buf2,"%.2s.%.2s.%.2s",&buf[6],&buf[8],&buf[12]);

   Table1->First();
   while(!Table1->Eof)
   {	y=1;
   		if(Table1->FieldByName("station")->AsString!= AnsiString(buf,5))     y=0;
	   	if(Table1->FieldByName("zeit")->AsString!= AnsiString(&buf[15],4))   y=0;
		if(Table1->FieldByName("von")->AsString != AnsiString(&buf[25+dl],8))y=0;
	    if(y==1)
    	{	Table1->Edit();
			Table1->FieldByName("Flag1")->AsInteger ++;
	      	Table1->Post();
		   	return 0;
	    }
       Table1->Next();
	}

	Table1->Append();
	Table1->Edit();					//vorbereiten einer Editierung eines F.
	Table1->FieldByName("Flag1")->AsInteger  = 1;
	Table1->FieldByName("Flag2")->AsInteger  = 0;
	Table1->FieldByName("Flag3")->AsInteger  = 0;
	Table1->FieldByName("station")->AsString = AnsiString(&buf[0],5);
	Table1->FieldByName("PDate")->AsString   = AnsiString(buf2,8);
	Table1->FieldByName("zeit")->AsString    = AnsiString(&buf[15],4);
	Table1->FieldByName("PLabel")->AsString  = AnsiString(&buf[20],
    											(unsigned char)(dl-1));
	Table1->FieldByName("bedcon")->AsString  = AnsiString(&buf[20+dl],4);
	Table1->FieldByName("von")->AsString     = AnsiString(&buf[25+dl],8);
    //Sicherheit: sporadischer Fehler, "bis" manchmal mehr als 8-stellig
    y=34;
    while((buf[y+8+dl] >= '0') && (buf[y+8+dl] <= '9'))		y++;
	Table1->FieldByName("bis")->AsString     = AnsiString(&buf[y+dl],8);
	Table1->Post();					//und Wert im Feld sichern

	return 1;
}

//---------------------------------------------------------------------------
//Grafik der Activ-Dateien Anzeigen und Ausdrucken
void __fastcall TForm1::grafikdruckClick(TObject *Sender)
{
   Form2->smartpc->Caption    = connectbox->Text;
	Form2->dateidatum->Caption = activfilebox->Text;

	int x, y, z, p;
   int nfd = 9999;								//Vers., Nachfolgedatum z.fi.
   char  an2[300];								//Name des nchsten Tages
   int an2laenge;
	FILE *file;

	TImage *i[4];
	i[1] = Form2->Image1;
	i[2] = Form2->Image2;
	i[3] = Form2->Image3;
	for(x=1; x<4; x++)
	{   //Wichtig: Rechteck wei fllen, sonst bleibt das alte Muster!!
    	TRect r = Rect(0,0,i[x]->Width,i[x]->Height);
    	i[x]->Canvas->FillRect(r);
    	i[x]->Canvas->Pen->Width = 2;				//Rahmen zeichnen
		i[x]->Canvas->Pen->Style = psSolid;
		i[x]->Canvas->MoveTo(0,0);
		i[x]->Canvas->LineTo(0,i[x]->Height);
		i[x]->Canvas->LineTo(i[x]->Width,i[x]->Height);
		i[x]->Canvas->LineTo(i[x]->Width,0);
		i[x]->Canvas->LineTo(0,0);

		i[x]->Canvas->Pen->Width = 1;				//senkrechte Punktlinien
		i[x]->Canvas->Pen->Style = psDot;
		for(y=60; y<600; y +=60)					//in diesem Abstand
		{	i[x]->Canvas->MoveTo(y,0);
			i[x]->Canvas->LineTo(y,i[x]->Height);
		}
		i[x]->Canvas->Pen->Style = psSolid;
		i[x]->Canvas->Pen->Width = 1;
	}

	if(0==(file=fopen(activname,"rb")))		 		//wenn Datei fehlt
	{	MessageBox(0,"Tagesdatei mu erst ausgewhlt sein !","Fehler !",MB_OK);
   	return;
   }
	for(x = 0; x < 360; x++)
		fgetc(file);								//bis 6 Uhr wegwrfen

	x=1;	//beim oberen Fenster beginnen
	y=0;	//Punkt 0 auf der Waagerechten
   while(1)
	{	if(nfd>1)   p = fgetc(file);				//nfd=1 wenn kein Tag+1
       if(p>96)								//a=Start/smartpc
       {	p -= 97;
			i[x]->Canvas->MoveTo(y,0);
			i[x]->Canvas->LineTo(y,10);				//dann oben kurze Linie
       }
       if(p>64)			p -= 63;			//A=Zeitjustage/smartpc
		if(p>47)			p -= 48;			//normale Labelzhlung
		if((p<0)||(nfd==1))		p=0;
		if(p>10)			p=10;
		i[x]->Canvas->MoveTo(y,i[x]->Height);
		i[x]->Canvas->LineTo(y++,i[x]->Height - 5 - p*10);

       if((y>509)&&(x==1))							//1.Schicht vorbei?
		{	x = 2;
           y = 30;								//Schicht 14.30
       }
       if((y>449)&&(x==2))							//2.Schicht vorbei?
		{	x = 3;
           y = 30;								//Schicht um halb
       }
       if((y==180)&&(x==3))						//3.Schicht Tageswechsel?
		{	fclose(file);
			//Versuch, Datei des Nachfolgedatums zu finden
           sprintf(an2,"%s",activname);
           an2laenge = strlen(an2);
		 	while(nfd--)
           {   an2[an2laenge-5]++;
           	for(z=an2laenge-5; z>an2laenge-13; z--)
           	{   if(an2[z]>'9')
                   {   an2[z]='0';
                       an2[z-1]++;
                   }
               }
           	Form2->QRLabel34->Caption = AnsiString(&an2[an2laenge-6],2)+"."+
                                           AnsiString(&an2[an2laenge-8],2)+"."+
                                           AnsiString(&an2[an2laenge-12],4);
				if(0!=(file=fopen(an2,"rb")))	break;
               if(nfd==1)
				{    Form2->QRLabel34->Caption = "Nachfolgetag nicht gefunden !";
                    break;
               }
           }
       }
       if((y>539)&&(x==3))        				//3.Schicht Ende?
       {	fclose(file);
       	break;
       }
	}
	Form2->QuickReport1->Preview();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::grafikdruck2Click(TObject *Sender)
{
	Form3->smartpc->Caption    = connectbox->Text;
	Form3->dateidatum->Caption = activfilebox->Text;

	int x, y, z=0, p;
   	//int nfd = 9999;								//Vers., Nachfolgedatum z.fi.
   	//char  an2[300];								//Name des nchsten Tages
   	//int an2laenge;
	FILE *file;

	//Wichtig: Rechteck wei fllen, sonst bleibt das alte Muster!!
    TRect r = Rect(0,0,Form3->Image1->Width,Form3->Image1->Height);
   	Form3->Image1->Canvas->FillRect(r);

   	Form3->Image1->Canvas->Pen->Width = 2;				//Rahmen zeichnen
	Form3->Image1->Canvas->Pen->Style = psSolid;
	Form3->Image1->Canvas->MoveTo(0,0);
	Form3->Image1->Canvas->LineTo(0,Form3->Image1->Height);
	Form3->Image1->Canvas->LineTo(Form3->Image1->Width,Form3->Image1->Height);
	Form3->Image1->Canvas->LineTo(Form3->Image1->Width,0);
	Form3->Image1->Canvas->LineTo(0,0);

	if(0==(file=fopen(activname,"rb")))		 		//wenn Datei fehlt
	{	MessageBox(0,"Kann Datei nicht ffnen !","Fehler !",MB_OK);
   		return;
    }
    
	Form3->Image1->Canvas->Pen->Width = 1;				//waager. Punktlinien
	Form3->Image1->Canvas->Pen->Style = psDot;
	for(y=0; y<Form3->Image1->Height; y +=Form3->Image1->Height/24)
	{	Form3->Image1->Canvas->MoveTo(0,y);
		if(y)
        {	Form3->Image1->Canvas->Pen->Color = clRed;
        	Form3->Image1->Canvas->LineTo(Form3->Image1->Width,y);
        	Form3->Image1->Canvas->TextOut(3, y-32, AnsiString(z++)+ " Uhr ");
        }
	}
	Form3->Image1->Canvas->Pen->Style = psSolid;
	Form3->Image1->Canvas->Pen->Width = 2;

	for(y=0; y<Form3->Image1->Height; y +=Form3->Image1->Height/24)
	{	Form3->Image1->Canvas->MoveTo(0,y);
    	for(x=0; x<60; x++)
        {  	p = fgetc(file);
    		if((p>='A') && (p<'Z'))		p-='A';
    		if(p>='a')					p-='a';
            if(p>='0')					p-='0';
        	if(p<0)						p=0;
            if(p>8)						p=8;
            Form3->Image1->Canvas->Pen->Color = clGreen;
        	Form3->Image1->Canvas->LineTo(x*9,y+34-p*3);
        }
    }
    fclose(file);
	Form3->QuickReport1->Preview();
}
//---------------------------------------------------------------------------
