//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "druck1.h"
#include "main.h"
#include <stdio.h>
//---------------------------------------------------------------------------
#define DX 700
#define DY 100

#pragma package(smart_init)
#pragma resource "*.dfm"
TFDruck1 *FDruck1;

int v, tag=0xff, stunde=0xff, minute=0xff;
AS LastTime;
FILE* datei;
int filepos = 0;
//---------------------------------------------------------------------------
__fastcall TFDruck1::TFDruck1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFDruck1::QuickRep1BeforePrint(TQuickRep *Sender,
      bool &PrintReport)
{
	datei = fopen("Flash.tmp","rb");
    if(datei == NULL)
        this->Close();
    //QRBand3->AddPrintable(TQRImage);

}
//---------------------------------------------------------------------------

void __fastcall TFDruck1::QuickRep1NeedData(TObject *Sender,
      bool &MoreData)
{
    char wotad[][3]={ "??","Mo","Di","Mi","Do","Fr","Sa","So" };

    MoreData = false;
   	//TRect r = Rect(0,0,QRImage1->Width,QRImage1->Height);
   	//QRImage1->Canvas->FillRect(r);
    if(fseek(datei,filepos,SEEK_SET))
	{   fclose(datei);
       	return;
    }
	for(int x=40; x<DX; x++)
	{   v = fgetc(datei);
    	if(v == EOF)
    	{   fclose(datei);
           	return;
        }
        while(v>127)
        {   if(v<188)               minute = v & 0x7f;
            if((v>223)&(v<232))     tag = v & 0x0f;
            if((v>191)&(v<216))     stunde = v & 0x1f;
            v = fgetc(datei);
        	if(v == EOF)
        	{   fclose(datei);
               	return;
            }
        }
        QRImage1->Canvas->Pen->Color = (TColor)0xaa901;
        QRImage1->Canvas->Pen->Mode  = pmCopy;
        QRImage1->Canvas->MoveTo(x,DY-20);
		QRImage1->Canvas->LineTo(x,DY-20 - v);
        if((tag!=255)&(stunde!=255)&(tag!=255))
        {   LastTime = AS(wotad[tag])+"/";
        	AS s = AS(stunde);
            if(s.Length()==1)	s = "0"+s;
            LastTime += s + ":";
            s = AS(minute);
            if(s.Length()==1)	s = "0"+s;
            LastTime += s;
            tag = stunde = minute = 0xff;
            QRImage1->Canvas->Pen->Mode  = pmMask;
            QRImage1->Canvas->Pen->Color =(TColor)0;
            QRImage1->Canvas->MoveTo(x,0);
		    QRImage1->Canvas->LineTo(x,DY-20);
	        QRImage1->Canvas->TextOut(x-5, DY-18, LastTime);
        }
    }
	//fclose(datei);
    for(v=DY-20; v>0; v -= 20)
    {   QRImage1->Canvas->Pen->Mode  = pmMask;
        QRImage1->Canvas->Pen->Color =(TColor)0;
        QRImage1->Canvas->MoveTo(20,v);
	    QRImage1->Canvas->LineTo(DX,v);
        QRImage1->Canvas->TextOut(1, v-6, AS(DY-v-20));
    }

}
//---------------------------------------------------------------------------
void __fastcall TFDruck1::FormClose(TObject *Sender, TCloseAction &Action)
{
    fclose(datei);
}
//---------------------------------------------------------------------------

