//---------------------------------------------------------------------------
#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <Grids.hpp>

#define     AS      			AnsiString
#define     LESEBUFFER          300000
#define     SCHREIBBUFFER       1000

//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// Komponenten, die von der IDE verwaltet werden
    TTimer *Timer1;
    TOpenDialog *OpenDialog1;
    TButton *DateiLaden;
    TButton *SetzteZeit;
    TButton *FlashLesen;
    TButton *SofortMessung;
	TButton *p1min;
    TButton *FlashLoeschen;
    TGroupBox *GroupBox1;
    TLabel *Label3;
    TLabel *LDatumZeit;
    TLabel *LArbeitsverzeichnis;
    TLabel *Label2;
    TGroupBox *GroupBox2;
	TLabel *LTag;
    TLabel *Label5;
	TPageControl *LMessValue;
    TTabSheet *TabSheet1;
    TTabSheet *TabSheet2;
    TTabSheet *TabSheet3;
    TStringGrid *StringGrid1;
    TLabel *Label6;
    TStringGrid *StringGrid2;
    TLabel *Label7;
    TStringGrid *StringGrid3;
    TStringGrid *StringGrid4;
    TLabel *Label8;
    TLabel *Label9;
	TButton *Weiter;
	TButton *Zurueck;
    TLabel *LR;
    TLabel *Label11;
    TLabel *W;
    TLabel *LW;
    TLabel *Label10;
	TLabel *LStu;
	TLabel *LMin;
	TLabel *LSendbytes;
	TButton *datastop;
	TButton *RAMlesen;
	TGroupBox *GroupBox3;
	TLabel *Level;
	TButton *DateiSpeichern;
	TSaveDialog *SaveDialog1;
	TButton *AnsEnde;
	TButton *AnDenAnfang;
	TImage *Image1;
	TButton *p1sek;
	TButton *p6sek;
	TButton *Button1;
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall DateiLadenClick(TObject *Sender);
	void __fastcall FlashLesenClick(TObject *Sender);
	void __fastcall SofortMessungClick(TObject *Sender);
	void __fastcall p1minClick(TObject *Sender);
	void __fastcall datastopClick(TObject *Sender);
	void __fastcall RAMlesenClick(TObject *Sender);
	void __fastcall DateiSpeichernClick(TObject *Sender);
	void __fastcall WeiterClick(TObject *Sender);
	void __fastcall ZurueckClick(TObject *Sender);
	void __fastcall AnsEndeClick(TObject *Sender);
	void __fastcall AnDenAnfangClick(TObject *Sender);
	void __fastcall SetzteZeitClick(TObject *Sender);
	void __fastcall FlashLoeschenClick(TObject *Sender);
	void __fastcall p1sekClick(TObject *Sender);
	void __fastcall p6sekClick(TObject *Sender);
    void __fastcall Button1Click(TObject *Sender);
private:	// Benutzerdeklarationen

public:		// Benutzerdeklarationen

    //char wotad[10][3];
	unsigned char ram[512];
    AS comport;                         //COM1, COM2 ....
    AS writebuffer;
    AS readbuffer;
    unsigned char pccommin[LESEBUFFER]; //wo die empf. Bytes hin sollen
    HANDLE hCom;                        //Adresse des COMPORT-Hndlers
    _SYSTEMTIME t;
    bool success;
    bool comopen;
    DCB dcb;                            //Devicecontrollblock (ca.28 Eintrge)
    OVERLAPPED o,o2;                    //Struktur enthlt Infos ber I/O-Daten
    COMMTIMEOUTS times;                 //die Timeout-Variablen des Ports
    COMSTAT comstat;                    //Stru.mit ca. 10 Eintrgen (Handshake)
	long filepos;						//Position, ab wann anzeigen
    unsigned long rb;                   //Die im Lesepuffer zur Verf. st. Bytes
    unsigned long errcode;              //wird von ClearCommError geliefert
    unsigned long transfer;
    unsigned long gelesen;              //Wieviele Bytes empf. wurden
    int vmin, vmax;						//Minimal- und Maximalmewert
    int baud;                           //Baudrate (meist 9600)
    int inaktiv;                        //InaktivCounter
    int timertic;                       //zum mitzaehlen
    int purgecomm;                      //ob Puffer gelscht werden sollen
    int bytesimschreibpuffer;           //Zahl der noch zu sendenden Bytes
    int bytesimlesepuffer;              //noch nicht in pccommin   bertr. Bytes
    int wblen;                          //Bytezahl im writepuffer + Start im Int
    int gx, gy;							//x/y - Variablen (ntig in Grafikdarst.
	unsigned char tag, stunde, minute;


        __fastcall TMainForm(TComponent* Owner);
    int __fastcall openport(void);
   void __fastcall compruef(void);
   void __fastcall saveini();
   void __fastcall leseport(void);
   void sendcommand(AS co);
   void __fastcall WrProt(AS PText);
   void __fastcall ZeigeGrafik(void);
   void __fastcall HoleMinMax(void);

};
//---------------------------------------------------------------------------
//extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
